/*
 * archiver.h - A[JCoC^[tFCX
 * --------------------------------------------------------------------
 * This file is completely in public domain. You can freely use, copy, 
 * modify, and redistribute the whole contents, without this notice.
 * --------------------------------------------------------------------
 */

/*
 * $Header: /home/niggle/src/vison/RCS/archiver.h,v 1.4 1993/10/08 00:29:29 Niggle Exp $
 *
 * $Log: archiver.h,v $
 * Revision 1.4  1993/10/08  00:29:29  Niggle
 * 񍐃[h
 *
 * Revision 1.3  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.2  1993/05/05  14:10:18  Niggle
 * R}h define
 *
 * Revision 1.1  1993/04/29  02:56:57  Niggle
 * Initial revision
 *
 */


/*
 *	T[o鎞ɂ́Cexts \̂`ĂCǂݍނƁD
 *	̂ƂɂSERVERdefine邱ƁD
 */

#ifndef SERVER
typedef struct
{
  unsigned char reserved[30];
} exts;
#endif SERVER

/*  T[o <-> NCAgԂŔsCxgR[h  */
typedef enum
{
  send_handle = 128,
  exited_archiver = 129,
  aborted_archiver = 130,
  send_report = 132,

  send_keep = 136,
  send_exit = 137,
  send_files_command = 138,
  set_directory = 139
} archiver_event;

/* R}hXe[^XGȂ */
#define AC_EXTRACT	(1)
#define	AC_FREEZE	(2)
#define	AC_DELETE	(4)

#define	AE_HANDLE	(0x100)
#define	AE_OVRWRT	(0x200)
#define	AE_TMSTMP	(0x400)
#define	AE_CHECK	(0x800)
#define	AE_FAST		(0x1000)

typedef struct
{
  long filename_offset;
  short omake;
  signed short command;
  unsigned short attribute;
  unsigned short time;
  unsigned short date;
  unsigned long file_size;
  unsigned long ext_command;
  int extend[3];
  union
    {
      unsigned char reserved[30];		/*  T[o̓Ǝdl  */
      exts ext;
    } reserved;
} archive_files;

typedef struct
{
  long header;
  unsigned short header_version;
  unsigned short command_mask;
  handle arc_file;
  unsigned char** filename;
  long number_of_files;
  archive_files block[0];
} archive;
