/*
 * usage.c - show ViSON informations.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: usage.c,v 1.3 1993/09/21 04:11:18 Niggle Exp $";

/*
 *$Log: usage.c,v $
 * Revision 1.3  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.2  1993/05/05  14:08:54  Niggle
 * A[JCũhbO󂯕t悤ɕύX
 *
 * Revision 1.1  1993/04/10  06:25:05  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<limits.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* Macros */
#define USAGE_X	(300)
#define USAGE_Y	(200)


/* File scope functions */
static Boolean draw_window (TASK *);
static Boolean left_down (TASK *);


/* File scope variables */
static Boolean UsageExist = nil;
static TASK *UsageTask = NULL;
static rectImg **_version;
static rectImg **_vison;
static rectImg **_nwsx;
static rectImg **_at;
static rectImg **_niggle;


/* Functions */
/************************************************
 *	UsageWindow ̕\			*
 ************************************************/
Boolean
show_usage (void)
{
  TASK *T;
  rect R;

  if (UsageExist)
    {
      ShowTask (UsageTask);
      WMSelect (UsageTask->winPtr);
      return nil;
    }

  for (T = &MyTASK; T->next != NULL; T = T->next)
    ;				/* nop */

  T = T->next = malloc (sizeof (TASK));
  if (T == NULL)
    {
      FatalError ("ShowUsage:Memory Exhaust.\n");
      return t;
    }
  SXGetDispRect (&R);
  GMCenterRect (&T->dRect, &R, USAGE_X * 0x10000 + USAGE_Y, 1);

  T->winPtr = WMOpen (
		       0,
		       &T->dRect,
		       (LASCII *) "\@ViSON",
		       0,
		       (WIN_ID << 4),
		       (window *) - 1,
		       -1,
		       TSGetID ()
    );

  if (T->winPtr == NULL)
    {
      TSErrDialogN (0x101, "EChEI[vł܂łD");
      return t;
    }

  GMSetGraph (&T->winPtr->wGraph);
  GMAPage (3);
  GMForeColor (G_BLACK);
  GMBackColor (G_LGRAY);
  GMPenMode (0);

  WMShow (T->winPtr);
  T->active_p = t;

  T->scBVHdl = NULL;
  T->scBHHdl = NULL;
  T->menuHdl1 = NULL;
  T->menuHdl2 = NULL;
  T->menuHdl3 = NULL;
  T->ISRec = NULL;
  T->files.next = NULL;
  T->parent = NULL;
  T->next = NULL;

  UsageExist = t;
  UsageTask = T;
  T->left_down_proc = left_down;
  T->draw_proc = draw_window;

  _vison = (rectImg **) TSRscGet ('pat3', 128);
  _version = (rectImg **) TSRscGet ('pat3', 129);
  _nwsx = (rectImg **) TSRscGet ('pat3', 130);
  _niggle = (rectImg **) TSRscGet ('pat3', 131);
  _at = (rectImg **) TSRscGet ('pat3', 132);

  return nil;
}

/************************************************
 *	UsageWindow hbO			*
 ************************************************/
Boolean
get_archive (void)
{
  if (!*ArcFileName)
    {
      /* A[JCuw肳ĂȂꍇ */

      if (UsageTask)
	{
	  if ((window *) tsEventRec.whom == UsageTask->winPtr)
	    {
	      drag *my_drag;

	      if (TSGetDrag (&my_drag) == 0)
		{
		  char *cel, *orign;

		  MMHdlLock ((handle) my_drag->cellHdl);
		  cel = orign = *my_drag->cellHdl;
		  while (cel - orign < my_drag->length)
		    {
		      if (*(short *) cel == 'FS')
			{
			  unsigned char path[PATH_MAX + 1];

			  TSISRecToStr ((icstate *) (cel + 8), (char *)path);

			  if (strlen ((char *) path))
			    {
			      TSEndDrag (0);

			      mbscpy (ArcFileName, path);
			      return exec_archiver (ArcFileName);
			    }
			  else
			    cel += *(int *) (cel + 4) + 8;
			}
		      else
			{
			  cel += *(int *) (cel + 4) + 8;
			}
		    }
		}
	      TSEndDrag (-1);
	    }
	}
    }
  return nil;
}


/* File scope functions */
/************************************************
 *	UsageWindow ̕`֐			*
 ************************************************/
static Boolean
draw_window (TASK * T)
{
  GMAPage (3);
  /* Ĕzu͔Ȃ */
  GMPutRImg (*_vison, (USAGE_X / 2 - (98 / 2)) * 0x10000 + 5);
  GMPutRImg (*_version, (USAGE_X / 2 - (42 / 2)) * 0x10000 + 40);
  GMPutRImg (*_niggle, (USAGE_X - 120) * 0x10000 + USAGE_Y - 20);
  GMPutRImg (*_at, (USAGE_X - 65) * 0x10000 + USAGE_Y - 20);
  GMPutRImg (*_nwsx, (USAGE_X - 50) * 0x10000 + USAGE_Y - 20);
  return nil;
}

/************************************************
 *	UsageWindow left_down			*
 ************************************************/
static Boolean
left_down (TASK * T)
{
  rect MinMaxRect = ((rect)
		     {WIN_X_MIN, WIN_Y_MIN, WIN_X_MAX, WIN_Y_MAX});

  if ((window *) tsEventRec.whom == T->winPtr)
    {
      /* cur Ńtg_ECxg */
      GMSetGraph (&T->winPtr->wGraph);
      if (!T->active_p)
	{
	  /* V[gJbgL[ĂƁCANeBx[gȂD */
	  if (!((*(int *) &tsEventRec.what2) & (1 << SHORTCUT)))
	    {
	      WMSelect (T->winPtr);
	    }
	}

      if (EMLStill ())
	{
	  int result;

	  result = SXCallWindMN (T->winPtr, &tsEventRec, &MinMaxRect);
	  switch (result)
	    {
	    case W_INDESK:
	    case W_ININSIDE:
	    case W_INDRAG:
	      break;

	    case W_INCLOSE:
	      return HideTask (T);
	      break;

	    case W_INZMOUT:
	    case W_INZMIN:
	    case W_INGROW:
	    case W_INARROW:
	    case W_INCLPON:
	    case W_INCLPOFF:
	    case W_INDRIVE:
	    default:
	      /* nop */
	      break;
	    }
	}
    }
  return nil;
}
