/*
 * window.c - window function for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: window.c,v 1.4 1993/09/21 04:11:18 Niggle Exp $";

/*
 *$Log: window.c,v $
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/04/29  02:53:01  Niggle
 * LeftDownCxg̃o[`
 *
 * Revision 1.2  1993/04/23  21:19:13  Niggle
 * rcsid̈ύX
 * ኱̍
 *
 * Revision 1.1  1993/04/09  12:10:41  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* File scope functions */
static Boolean draw_window (TASK *);


/* Functions */
/************************************************
 *		EChE쐬		*
 ************************************************/
Boolean
make_window (TASK * T)
{
  LASCII winTitle;
  window *my_window;

  if (T->winTitle.length)
    {
      /* TufBNgȉȂfBNgEChE^Cgɂ */
      winTitle.length = T->winTitle.length;
      mbscpy (winTitle.Lstr, T->winTitle.Lstr);
    }
  else
    {
      /* [gfBNgȂA[JCuEChE^Cgɂ */
      winTitle.length = strlen ((char *) ArcFileName);
      mbscpy (winTitle.Lstr, ArcFileName);
    }
  T->next = NULL;
  T->dRect = MyWinRect;
  T->winPtr = WMOpen (
		       0,
		       &MyWinRect,
		       &winTitle,
		       0,
		       (WIN_ID << 4) + WIN_OPT,
		       0,
		       -1,
		       TSGetID ()
    );
  if (!T->winPtr)
    {
      TSErrDialogN (1, "EChEI[vł܂łD");
      return t;
    }
  my_window = T->winPtr;

  GMSetGraph (&my_window->wGraph);
  GMAPage (7);
  GMForeColor (G_BLACK);
  GMBackColor (G_LGRAY);

  {
    unsigned int winopt = WIN_OPTION;

    if (clip_p)
      winopt |= WC_CLIPON;

    if (T->winTitle.length)
      {
	/* TufBNg */
	my_window->wTask += 0x10000;
	WMCarry (my_window, MyTASK.next->winPtr);
	if (recursive_p)
	  WMShow (my_window);
	winopt |= WC_ARROW;
	T->active_p = nil;
      }
    else
      {
	/* [gfBNg */
	WMShow (my_window);
	WMSelect (my_window);
	winopt |= WC_DRIVE;
	T->active_p = t;
      }

    WMOptionSet (winopt);
  }
  WMTitleGet (my_window, &winTitle);
  WMTitleSet (my_window, &winTitle);

  T->left_down_proc = MSLDownSub;	/* event.c */
  T->draw_proc = draw_window;
  return nil;
}

/************************************************
 *		EChE̔p		*
 ************************************************/
void
dispose_window (TASK * T)
{
  window *w;
  if ((w = T->winPtr))
    WMDispose (w);

  return;
}


/* File scope functions */
/************************************************
 *		EChE̕`		*
 ************************************************/
static Boolean
draw_window (TASK * T)
{
  if (T->scBVHdl && T->scBHHdl)
    draw_scrollbar (T);

  if (T->ISRec)
    draw_icons (T);

  if (WMOptionGet () & WC_GBOX)
    WMDrawGBox (T->winPtr);

  return nil;
}
