/*
 * event.c
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: event.c,v 1.5 1993/10/08 00:26:41 Niggle Exp $";

/*
 *$Log: event.c,v $
 * Revision 1.5  1993/10/08  00:26:41  Niggle
 * 𓀎Ƀ^CX^vrg悤ɏύX
 *
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/05/05  14:09:29  Niggle
 * ܂܂ȃoOtBbNX
 *
 * Revision 1.2  1993/04/29  21:29:50  Niggle
 * hbO̒ǉ
 *
 * Revision 1.1  1993/04/09  15:12:30  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include<mbstring.h>
#include<limits.h>
#include<sys/stat.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"
#include"archiver.h"


/* File scope functions */
static Boolean MSRDownSub (TASK * T);
static Boolean left_down_on_icon (TASK *, int);
static Boolean right_down_on_icon (TASK *, int);
static void first_left_down (TASK *, int, int);
static void list_extract_files (int *, int *, int *, TASK *);
static void exec_with_left (void);
static void exec_with_right (void);
static void get_rect (TASK *, rect *);


/* File scope variables */
static icstate *ExecISRec;
static unsigned char ExecDirName[PATH_MAX + 1];
static unsigned char command[512];
static LASCII option;

static int itemNo;
static char **ShME_hdl;
static unsigned char cmdLine[PATH_MAX + 1];


/* Functions */
/************************************************
 *	AChCxg			*
 ************************************************/
Boolean
Idle (void)
{
  TASK *cur;

  /*	XN[o[	*/
  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      if (cur->click_p && EMLStill ())
	{
	  int result;
	  control **ctrlHdl = NULL;
	  rect r = (rect)
	  {0, 0, cur->dRect.right, cur->dRect.bottom};

	  result = SXCallCtrlM (
				 cur->winPtr,
				 &tsEventRec,
				 cur->scBVHdl,
				 cur->scBHHdl,
				 &r,
				 &ctrlHdl
	    );
	  if (result == C_INUP || result == C_INDOWN)
	    {
	      draw_scrollbar (cur);
	      cur->click_p = t;
	    }
	  else
	    cur->click_p = nil;

	  break;
	}
      else
	cur->click_p = nil;
    }

  /*	𓀂IĂs	*/
  if (exec_p && ExecProc)
    (ExecProc) ();
  exec_p = nil;

  return nil;
}

/************************************************
 *	tg_ECxg		*
 ************************************************/
Boolean
MSLDown (void)
{
  Boolean result = nil;
  TASK *cur;

  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      result = (*(cur->left_down_proc)) (cur);

      if (result)
	break;
    }

  return result;
}


/************************************************
 *	tgAbvCxg		*
 ************************************************/
Boolean
MSLUp (void)
{
  return nil;
}

/************************************************
 *	Cg_ECxg		*
 ************************************************/
Boolean
MSRDown (void)
{
  Boolean result = nil;
  TASK *cur;

  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      result = MSRDownSub (cur);

      if (result)
	break;
    }
  return result;
}

/************************************************
 *	CgAbvCxg		*
 ************************************************/
Boolean
MSRUp (void)
{
  return nil;
}

/************************************************
 *	L[_ECxg			*
 ************************************************/
Boolean
KeyDown (void)
{
  TASK *cur;

  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      if (cur->active_p)
	{
	  int AsciiCode = tsEventRec.whom & 0xff;
	  if ((*(int *) &tsEventRec.what2) & (1 << SHORTCUT))
	    {
	      switch (AsciiCode)
		{
		case 'Q':
		  /* I */
		  return t;
		case 'q':
		  /* EChE */
		  TSGetEvent (EM_KEYDOWN, &tsEventRec);
		  return HideTask (cur);
		case 'I':
		case 'i':
		  /* AboutWindow J */
		  return show_usage ();
		case 'a':
		  /* S}[N */
		  if (cur->ISRec)
		    {
		      GMSetGraph (&cur->winPtr->wGraph);
		      SetisSelFlag (cur, cur->sNum, cur->eNum, 1);
		    }
		  break;

		case 'A':
		  /* ׂẴEChẼACRS}[N */
		  {
		    TASK *T;
		    for (T = MyTASK.next; T != NULL; T = T->next)
		      {
			if (T->ISRec)
			  {
			    GMSetGraph (&T->winPtr->wGraph);
			    SetisSelFlag (T, T->sNum, T->eNum, 1);
			  }
		      }
		  }
		  break;

		case 'x':
		  /* }[Nt@C */
		  ExtractOneWindow (AE_TMSTMP, DstDirName, cur);
		  if (!auto_open_p)
		    break;
		  /* 𓀐I[v */
		  {
		    LASCII options;

		    options.length = strlen ((char *) DstDirName);
		    mbscpy (options.Lstr, DstDirName);
		    TSFockB (0, 0, "di.r", &options, 0, 0);
		  }
		  break;
		case 'X':
		  /* ׂẴEChẼ}[Nt@C */
		  Extract (AE_TMSTMP, DstDirName);
		  if (!auto_open_p)
		    break;
		  {
		    /* 𓀐I[v */
		    LASCII options;

		    options.length = strlen ((char *) DstDirName);
		    mbscpy (options.Lstr, DstDirName);
		    TSFockB (0, 0, "di.r", &options, 0, 0);
		  }
		  break;

		case 'o':
		case 'O':
		  {
		    LASCII options;

		    options.length = strlen ((char *) DstDirName);
		    mbscpy (options.Lstr, DstDirName);
		    TSFockB (0, 0, "di.r", &options, 0, 0);
		  }
		  break;
		case 'd':
		case 'D':
		  get_extract_directory ();
		  break;
		default:
		  break;
		}
	    }
	}
    }
  return nil;
}

/************************************************
 *	L[AbvCxg			*
 ************************************************/
Boolean
KeyUp (void)
{
  return nil;
}

/************************************************
 *	Abvf[gCxg		*
 ************************************************/
Boolean
Update (void)
{
  TASK *cur;

  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      if (cur->winPtr == (window *) tsEventRec.whom)
	{
	  if (cur->winPtr->wVisible)
	    {
	      GMSetGraph (&cur->winPtr->wGraph);
	      WMUpdate (cur->winPtr);
	      if (cur->scBVHdl && cur->scBHHdl)
		hide_scrollbar (cur);
	      (*cur->draw_proc) (cur);
	      WMUpdtOver (cur->winPtr);
	    }
	}
    }
  return nil;
}

/************************************************
 *		Activate Event			*
 ************************************************/
Boolean
Activate (void)
{
  TASK *cur;

  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      if ((window *) tsEventRec.whom == cur->winPtr)
	{
	  if (cur->winPtr->wVisible)
	    {
	      cur->active_p = t;
	    }
	  else
	    {
	      /* sȃEChEZNgꂽ */
	      ShowTask (cur);
	      cur->active_p = t;
	    }
	}
      else
	{
	  cur->active_p = nil;
	}
    }

  /* łANeBuȃEChE EVENT_MASK_ACTIVE 
     ׂăCANeBuȂ EVENT_MASK_INACTIVE Cxg}XNɐݒ */
  tsEventMask = EVENT_MASK_INACTIVE;
  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    {
      if (cur->active_p)
	{
	  tsEventMask = EVENT_MASK_ACTIVE;
	  break;
	}
    }
  return nil;
}

/************************************************
 *		System Event			*
 ************************************************/
Boolean
System (void)
{
  switch (tsEventRec.what2)
    {
    case ENDTSK:
      return t;
      break;
    case CLOSEALL:
      return t;
      break;
    case NOTICEEJECT:		/* Xv[fBNgȂǂ܂܂ĂƏI */
    case DISKEJECT:
    case NOTICEFORMAT:
    case DISKFORMAT:
      {
	int spool_drive, dst_drive;
	drinfo drive = *(drinfo *) & tsEventRec.whom2;

	spool_drive = SpoolDirName[0];
	if (islower (spool_drive))
	  spool_drive -= 'a';
	else
	  spool_drive -= 'A';

	dst_drive = DstDirName[0];
	if (islower (dst_drive))
	  dst_drive -= 'a';
	else
	  dst_drive -= 'A';

	if (spool_drive == drive.driveno || dst_drive == drive.driveno)
	  return t;
      }
      break;
    case RMDIR:
      {
	unsigned char buf[PATH_MAX + 1];
	unsigned char buf2[PATH_MAX + 1];
	unsigned char buf3[PATH_MAX + 1];

	mbsupr (mbscpy (buf, *(unsigned char **) tsEventRec.whom));
	mbsupr (mbscpy (buf3, SpoolDirName));

	if (!mbscmp (buf, buf2) || !mbscmp (buf, buf3))
	  {
	    return t;
	  }
      }
      break;
    case DELETEFILE:		/* A[JCuǂ`FbN */
    case MOVEFILE:
    case COPYFILE:		/* ]悪A[JCu */
      /* ςA[JCo̕Ƀ`FbN܂悤  */
      break;
    case NOTICEENDTSK:
      break;
    case CHANGEDRSC:		/* ACR蒼 */
      if (tsEventRec.whom == 'PAT3' ||
	  tsEventRec.whom == 'PAT4' ||
	  tsEventRec.whom == 'ICN#')
	{
	  TASK *cur;

	  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
	    {
	      if (cur->ISRec)
		{
		  dispose_icons (cur);
		  cur->dRect.left = 0;
		  cur->dRect.top = 0;
		  cur->dRect.right = (cur->winPtr->wGraph.grRect.right
				      - cur->winPtr->wGraph.grRect.left);
		  cur->dRect.bottom = 0;
		  make_icons (cur);

		  {
		    rect r = cur->winPtr->wGraph.grRect;
		    r.right -= (SCB_WIDTH);
		    r.bottom -= (SCB_WIDTH);

		    GMSetGraph (&cur->winPtr->wGraph);
		    GMPenMode (G_BACK);
		    GMFillRect (&r);
		    GMPenMode (G_FORE);
		  }

		  hide_scrollbar (cur);
		  (*cur->draw_proc) (cur);
		}
	    }
	}
      break;
    case FOCKCHD:
    case FOCKALL:
    case FOCKCELL:
    case FOCKNOTHEAD:
      break;
    case SAVE:
      break;
    case WINDOWSELECT:
      break;
    case DRAGNOW:
      break;
    case DRAGEND:
      return get_archive ();	/* usage.c */
      break;
    default:
      return SystemProc ();	/* archiver.c */
    }
  return nil;
}

/************************************************
 *	tg_ECxg		*
 ************************************************/
Boolean
MSLDownSub (TASK * T)
{
  rect MinMaxRect = ((rect)
		     {WIN_X_MIN, WIN_Y_MIN, WIN_X_MAX, WIN_Y_MAX});

  if ((window *) tsEventRec.whom != T->winPtr)
    {
      /* ʂ̃EChEŃtg_ECxg̏D
	 Cxg̋NEChȄLEChEłȂC
	 CVtgL[ĂȂꍇɃACȒIt
	 ONAD*/
      if (!((*(int *) &tsEventRec.what2) & (1 << EH_SHFT)))
	{
	  /* VtgL[ĂȂ */
	  GMSetGraph (&T->winPtr->wGraph);
	  SetisSelFlag (T, T->sNum, T->eNum, 0);
	  return nil;
	}
      else
	{
	  /* VtgL[Ă */
	  TASK *cur;

	  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
	    {
	      if ((window *) tsEventRec.whom == T->winPtr)
		return nil;
	    }
	  GMSetGraph (&T->winPtr->wGraph);
	  SetisSelFlag (T, T->sNum, T->eNum, 0);
	  return nil;
	}
    }
  else
    {
      /* cur Ńtg_ECxg */
      GMSetGraph (&T->winPtr->wGraph);
      if (!T->active_p)
	{
	  /* V[gJbgL[ĂƁCANeBx[gȂD */
	  if (!((*(int *) &tsEventRec.what2) & (1 << SHORTCUT)))
	    {
	      /* ACR̃NbN̏ꍇCANeBx[gȂD */
	      if (ISPtInIcon (T, (point_t) GMGlobalToLocal (tsEventRec.whom2)) < 0)
		WMSelect (T->winPtr);
	    }
	}

      if (EMLStill ())
	{
	  int result;
	  rect r = T->winPtr->wGraph.grRect;

	  result = SXCallWindMN (T->winPtr, &tsEventRec, &MinMaxRect);
	  switch (result)
	    {
	    case W_INDESK:
	      break;

	    case W_ININSIDE:
	      {
		rect r = (rect)
		{0, 0, T->dRect.right, T->dRect.bottom};
		control **ctrlHdl = NULL;
		result = SXCallCtrlM (T->winPtr,
				      &tsEventRec,
				      T->scBVHdl,
				      T->scBHHdl,
				      &r,
				      &ctrlHdl);
		if (result == C_INUP
		    || result == C_INDOWN
		    || result == C_INPGUP
		    || result == C_INPGDOWN
		    || result == C_INTHUMB)
		  {
		    draw_scrollbar (T);
		    T->click_p = t;
		  }
		else if (!result)
		  {
		    int iNum;

		    iNum = ISPtInIcon (T, GMGlobalToLocal (tsEventRec.whom2));
		    left_down_on_icon (T, iNum);
		  }
	      }
	      break;

	    case W_INDRAG:
	      break;

	    case W_INCLOSE:
	      return HideTask (T);
	      break;

	    case W_INZMOUT:
	    case W_INZMIN:
	      GMSetHome (0);
	      re_calc_scrollbar (T);
	      break;
	    case W_INGROW:
	      {
		rect r2 = T->winPtr->wGraph.grRect;
		if (!GMEqualRect (&r, &r2))
		  re_calc_scrollbar (T);
	      }
	      break;

	    case W_INARROW:
	      if (WMOptionGet () & WC_CLIPON)
		HideTask (T);

	      if (T->parent == NULL)
		{
		  FatalError ("G[: efBNg NULL łD\n");
		  return nil;
		}

	      if (!T->parent->winPtr->wVisible)
		ShowTask (T->parent);

	      WMSelect (T->parent->winPtr);
	      break;
	    case W_INCLPON:
	      break;

	    case W_INCLPOFF:
	      break;

	    case W_INDRIVE:
	      break;

	    default:
	      /* nop */
	      break;
	    }
	}
    }
  return nil;
}

/********************************************************
 *	w肵TASKwindow D			*
 *	ׂẴEChEꍇ͏I	*
 ********************************************************/
Boolean
HideTask (TASK * T)
{
  TASK *cur;

  {
    /*	eEChE΁CΉfBNgACRD*/
    TASK *parent;


    if ((parent = T->parent))
      {
	files *F;

	for (F = parent->files.next; F != NULL; F = F->next)
	  {
	    if (F->dir == T->files.next)
	      {
		if (parent->winPtr->wVisible)
		  {
		    GMSetGraph (&parent->winPtr->wGraph);
		    GMPenMode (G_BACK);
		    GMFillRect (&parent->ISRec[F->IsRecNum].image);
		    GMPenMode (G_FORE);
		    change_pattern (parent, F->IsRecNum, DIR_ICON_NUM);
		    draw_a_icon (parent, F->IsRecNum);
		  }
		else
		  change_pattern (parent, F->IsRecNum, DIR_ICON_NUM);

		break;
	      }
	  }
      }
  }

  if (T->active_p)
    {
      /* window list ǂCrWuȂ̂ANeBx[g */
      window *cur;
      for (cur = T->winPtr->wNext; cur != NULL; cur = cur->wNext)
	if (cur->wVisible)
	  {
	    WMSelect (cur);	/* ̃EChEANeBuɂ */
	    break;
	  }
    }
  T->active_p = nil;

  WMHide (T->winPtr);

  /* visible ȃEChEȂȂI */
  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
    if (cur->winPtr->wVisible)
      return nil;

  return t;
}

/********************************************************
 *	w^XNɂ				*
 ********************************************************/
Boolean
ShowTask (TASK * T)
{
  WMShow (T->winPtr);
  return nil;
}

/********************************************************
 *							*
 ********************************************************/
void
Extract (int option, unsigned char *dirName)
{
  TASK *T;
  int *c;
  int size;
  int index;

  c = malloc (512 * sizeof (int));
  if (!c)
    {
      FatalError ("Extract: MemoryExaust\n");
      return;
    }

  index = 0;
  size = 512;

  for (T = MyTASK.next; T != NULL; T = T->next)
    list_extract_files (c, &index, &size, T);

  if (ExtractProc)
    (*ExtractProc) (index, c, dirName, option);

  free (c);
}

/************************************************
 *	EChEw̉			*
 ************************************************/
void
ExtractOneWindow (int option, unsigned char *dirName, TASK * T)
{
  int *c;
  int size;
  int index;

  c = malloc (512 * sizeof (int));
  if (!c)
    {
      FatalError ("Extract: MemoryExaust\n");
      return;
    }
  index = 0;
  size = 512;

  list_extract_files (c, &index, &size, T);

  if (ExtractProc)
    (*ExtractProc) (index, c, dirName, option);

  free (c);
}


/* File scope functions */
/************************************************
 *		Cg_E		*
 ************************************************/
static Boolean
MSRDownSub (TASK * T)
{
  if ((window *) tsEventRec.whom == T->winPtr)
    {
      int iNum;

      if (!T->menuHdl1)
	return nil;

      GMSetGraph (&T->winPtr->wGraph);
      iNum = ISPtInIcon (T, GMGlobalToLocal (tsEventRec.whom2));
      if (iNum >= 0)
	right_down_on_icon (T, iNum);
      else
	{
	  if (T->active_p || (*(int *) &tsEventRec.what2 & (1 << SHORTCUT)))
	    {
	      if (*(int *) &tsEventRec.what2 & (1 << EH_SHFT))
		{
		  return select_shift_menus (T);
		}
	      else if (*(int *) &tsEventRec.what2 & (1 << EH_XF1))
		{
		  return select_xf1_menus (T);
		}
	      else
		{
		  return select_menus (T);
		}
	    }
	}
    }
  return nil;
}

/********************************************************
 *	ACRŉENbNꂽ̏		*
 ********************************************************/
static Boolean
left_down_on_icon (TASK * T, int iNum)
{
  if (iNum < 0)
    {
      /* NbNꏊɂ̓ACR͂ȂD*/
      /* `ZNg */
      rect r;

      /* VtgL[ĂƃNAȂ */
      if (!(*(int *) &tsEventRec.what2 & (1 << EH_SHFT)))
	SetisSelFlag (T, T->sNum, T->eNum, 0);

      if (T->ISRec)
	{
	  get_rect (T, &r);
	  select_icons_in_rect (T, &r);
	}
    }
  else
    {
      /* ACRNbN */
      int isSel = T->ISRec[iNum].rsv[0];

      if ((EMSysTime () - T->LastClick) < EMDClickGet ())
	{
	  if (isSel == 1)
	    {
	      /* _uNbN */
	      files *F;

	      F = search_files (&T->files, iNum);
	      if (!F)
		{
		  FatalError ("G[: SearchFiles ̕Ԃl NULL łD");
		  return t;
		}

	      if (S_ISDIR (F->attribute))
		{
		  /* _uNbNꂽ̂̓fBNgACR */
		  TASK *cur;
		  unsigned char buff[PATH_MAX + 1];

		  mbscpy (buff, T->winTitle.Lstr);
		  mbscat (buff, F->dirName);
		  for (cur = MyTASK.next; cur != NULL; cur = cur->next)
		    {
		      if (!mbscmp (buff, cur->winTitle.Lstr))
			{
			  if (!cur->winPtr->wVisible)
			    {
			      change_pattern (T, iNum, OPEN_DIR_ICON_NUM);
			      if (WMOptionGet () & WC_CLIPON)
				{
				  GMSetGraph (&cur->winPtr->wGraph);
				  WMOptionSet (WMOptionGet () | WC_CLIPON);
				  HideTask (T);
				}
			      else
				{
				  GMSetGraph (&T->winPtr->wGraph);
				  GMPenMode (G_BACK);
				  GMFillRect (&T->ISRec[iNum].image);
				  GMPenMode (G_FORE);
				  draw_a_icon (T, iNum);
				}
			      ShowTask (cur);
			    }
			  WMSelect (cur->winPtr);
			}
		    }
		}
	      else
		{
		  /* _uNbNꂽ̂̓t@CACR */

		  ExecISRec = &T->ISRec[iNum];

		  TSISRecToExec (ExecISRec, (char *) command, &option);
		  option.length = strlen ((char *) option.Lstr);
		  if (strlen ((char *) command))
		    {
		      if (*(int *) &tsEventRec.what2 & (1 << SHORTCUT))
			{
			  unsigned char buff[512];

			  mbscpy (buff, command);
			  mbscpy (command, (unsigned char *) "cshell.r");

			  mbscat (buff, (unsigned char *) " ");
			  mbscat (buff, option.Lstr);
			  mbscat (buff, (unsigned char *) "\"");
			  mbscpy (option.Lstr, (unsigned char *) "\"");
			  mbscat (option.Lstr, buff);
			  option.length = strlen ((char *) option.Lstr);
			}

		      ExecProc = exec_with_left;
		      Extract (AE_OVRWRT, SpoolDirName);
		    }
		}
	    }
	  else
	    {
	      /* _uNbNԓɈقȂQ̃ACR
		 NbNꂽꍇD*/
	      first_left_down (T, isSel, iNum);
	    }
	}
      else
	{
	  /* ߂ăNbNꂽꍇD */
	  first_left_down (T, isSel, iNum);

	  while (EMLStill ())
	    {
	      if (GMLocalToGlobal (EMMSLoc ()) != tsEventRec.whom2)
		break;
	    }

	  if (GMLocalToGlobal (EMMSLoc ()) != tsEventRec.whom2)
	    {
	      /* hbO */
	      XDRG xdrg;
	      XDRG *xhdl;
	      handle cel_list;

	      TSZeroDrag ();

	      make_xdrg (&xdrg);
	      xhdl = &xdrg;

	      TSPutDrag (sizeof (XDRG), (handle) & xhdl);

	      cel_list = a3ba (&T->ISRec, T->sNum, T->eNum, 0x017f7f7f);
	      {
		int i;
		int tmp = MMHdlSizeGet (cel_list) / (sizeof (icstate) + 8);
		char *p;

		p = *cel_list;
		for (i = 0; i < tmp; i++)
		  {
		    if (*(int *) p == ('FS' << 16))
		      {
			*(int *) p = 'FSMC';
			(*(icstate *) (p + 8)).rsv[2] = 1;
		      }

		    p = p + sizeof (icstate) + 8;
		  }
	      }

	      TSPutDrag (MMHdlSizeGet (cel_list), cel_list);
	      MMHdlDispose (cel_list);

	      {
		TASK *cur;
		int *c;
		int size;
		int index;

		c = malloc (512 * sizeof (int));
		if (!c)
		  {
		    FatalError ("Extract: MemoryExaust\n");
		    return t;
		  }
		index = 0;
		size = 512;

		for (cur = MyTASK.next; cur != NULL; cur = cur->next)
		  list_extract_files (c, &index, &size, cur);

		write_command (index, c, SpoolDirName, AE_OVRWRT | AE_FAST);
		free (c);
	      }

	      TSBeginDrag (GMLocalToGlobal (EMMSLoc ()));
	    }
	}
    }
  return nil;
}

/************************************************
 *	t@[XgNbN(not Double)		*
 ************************************************/
static void
first_left_down (TASK * T, int isSel, int iNum)
{
  T->LastClick = EMSysTime ();

  if (!(*(int *) &tsEventRec.what2 & (1 << EH_SHFT)))
    {
      /* VtgL[ĂȂꍇD*/
      if (!T->ISRec[iNum].rsv[0])
	{
	  SetisSelFlag (T, T->sNum, T->eNum, 0);
	  SetisSelFlag (T, iNum, iNum + 1, 1);
	}
    }
  else
    {
      /* VtgL[ĂꍇD*/
      if (isSel)
	SetisSelFlag (T, iNum, iNum + 1, 0);
      else
	SetisSelFlag (T, iNum, iNum + 1, 1);
    }
  return;
}

/************************************************
 *	ACRŉENbNꂽ̏	*
 ************************************************/
static Boolean
right_down_on_icon (TASK * T, int iNum)
{
  ickind **Icn_hdl;
  menu **icn_menu;
  int ShME_id;
  handle MDEF;
  handle cel_list;

  ExecISRec = &T->ISRec[iNum];
  Icn_hdl = (ickind **) TSRscGet2 ('ICN#', ExecISRec->iconid, 0);
  if (!Icn_hdl)
    return t;

  if (!((*Icn_hdl)->attrib & 0x01))
    return nil;


  if (*(int *) &tsEventRec.what2 & (1 << EH_SHFT))
    {
      /* shift ̃j[ */
      ShME_id = (*Icn_hdl)->menuid2;
    }
  else
    {
      /* j[ */
      ShME_id = (*Icn_hdl)->menuid1;
    }
  ShME_hdl = (char **) TSRscGet2 ('ShME', ShME_id, 0);
  if (!ShME_hdl)
    return nil;

  icn_menu = a3eb ((handle) ShME_hdl);
  if (!icn_menu)
    {
      return t;
    }

  MDEF = TSRscGet2 ('MDEF', **ShME_hdl, 0);
  if (!MDEF)
    {
      MMHdlDispose ((handle) icn_menu);
      return t;
    }


  {
    LASCII menu_title;

    (*icn_menu)->mProc = (int) MDEF;
    put_filename (menu_title.Lstr, (unsigned char *) ExecISRec->name);
    menu_title.length = strlen ((char *) menu_title.Lstr);
    (*icn_menu)->mHandle = (int) &menu_title;

    mbscpy (ExecDirName, SpoolDirName);
    mbscat (ExecDirName, (unsigned char *) "\\");
    mbscat (ExecDirName, T->winTitle.Lstr);

    cel_list = a3ba (&T->ISRec, iNum, iNum + 1, 0x7f7f7f7f);
    if (!cel_list)
      {
	MMHdlDispose ((handle) icn_menu);
	return t;
      }

    a3c5 (cel_list, cmdLine);
    (*icn_menu)->mEnable = a3ed (cel_list, (handle) ShME_hdl);

    if (EMRStill ())
      {
	itemNo = MNSelect (icn_menu, (point_t) tsEventRec.whom2);
	if (itemNo > 0)
	  {
	    int rsv;

	    ExecProc = exec_with_right;

	    rsv = ExecISRec->rsv[0];
	    ExecISRec->rsv[0] = 1;
	    Extract (AE_OVRWRT, SpoolDirName);
	    ExecISRec->rsv[0] = rsv;
	    exec_p = nil;

	    MMHdlDispose (cel_list);
	    return nil;
	  }

	MMHdlDispose (cel_list);
	MMHdlDispose ((handle) icn_menu);
      }
    MMHdlDispose (cel_list);
    MMHdlDispose ((handle) icn_menu);
  }
  return nil;
}

/************************************************
 *	IĂt@CzɂD	*
 ************************************************/
static void
list_extract_files (int *c, int *index, int *size, TASK * T)
{
  int i;
  icstate *I;

  for (I = T->ISRec, i = T->sNum; i < T->eNum; I++, i++)
    {

      /* z̑傫`FbN */
      if (*index == *size)
	{
	  if (realloc (c, *size + 512 * sizeof (int)) == NULL)
	      FatalError ("list_extract_files: Memory Exhaust\n");
	  *size += 512;
	}

      /* IĂACRΉarchive_files̔ԍ𓾂 */
      if (I->rsv[0] == 1)
	{
	  files *F;

	  for (F = T->files.next; F != NULL; F = F->next)
	    {
	      if (F->IsRecNum == i)
		break;
	    }
	  if (F && F->Num >= 0)
	    c[(*index)++] = F->Num;
	}
    }
}

/************************************************
 *	tg_E̎s		*
 ************************************************/
static void
exec_with_left (void)
{

  if (TSFockB (0, 0, (char *)command, &option, 0, 0) < 0)
    FatalError ("̃t@C͎sł܂D");
  ExecProc = NULL;
  exec_p = nil;

  TSGetEvent (EM_IDLE, &tsEventRec);
  return;
}

/************************************************
 *	Cg_E̎s		*
 ************************************************/
static void
exec_with_right (void)
{
  int tmp;

  tmp = a3ec ((handle) ShME_hdl, itemNo, cmdLine);
  ExecProc = NULL;

  if (tmp > 0)
    FatalError ("%d", tmp);
  return;
}

/************************************************
 *		`ZNg			*
 ************************************************/
static void
get_rect (TASK * T, rect * dstRect)
{
  point orig;			/* ŏɃNbNꂽʒu */
  point last;			/* Öʒu */
  rect r;
  rect clipR;			/* NbsOp */
  region **rHdl;
  int pen_mode;			/* y[h̕ۑ */

  GMSetGraph (&T->winPtr->wGraph);

  /* Nbv[WۑCD */
  rHdl = GMNewRgn ();
  GMGetClip (rHdl);
  clipR = T->winPtr->wGraph.grRect;
  clipR.right -= SCB_WIDTH;
  clipR.bottom -= SCB_WIDTH;
  GMClipRect (&clipR);

  pen_mode = GMPenMode (3) & 0xffff;	/* sxlib's bug */

  *(int *) &last = GMGlobalToLocal ((point_t) tsEventRec.whom2);
  orig = last;
  r = (rect)
  {
    last.x, last.y, last.x, last.y
  };
  GMFrameRect (&r);

  while (EMLStill ())
    {
      point cur;

      *(int *) &cur = EMMSLoc ();
      if (*(int *) &cur != *(int *) &last)
	{
	  GMFrameRect (&r);

	  last = cur;
	  r.left = (orig.x > cur.x) ? cur.x : orig.x;
	  r.top = (orig.y > cur.y) ? cur.y : orig.y;
	  r.right = (orig.x < cur.x) ? cur.x : orig.x;
	  r.bottom = (orig.y < cur.y) ? cur.y : orig.y;

	  GMFrameRect (&r);
	}
    }
  GMFrameRect (&r);

  GMPenMode (pen_mode);

  /*	Nbv[Wǂ	*/
  GMSetClip (rHdl);
  GMDisposeRgn (rHdl);

  *dstRect = r;
  return;
}
