/*
 * function.h - for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

/*
 * $Header: /home/niggle/src/vison/RCS/function.h,v 1.4 1993/10/08 00:30:51 Niggle Exp $
 *
 * $Log: function.h,v $
 * Revision 1.4  1993/10/08  00:30:51  Niggle
 * 𓀎Ƀ^CX^vrg悤ɏύX
 *
 * Revision 1.3  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.2  1993/05/04  13:31:08  Niggle
 * re-format only
 *
 * Revision 1.1  1993/04/29  02:55:12  Niggle
 * Initial revision
 *
 */

/*
 *	main.c
 */
TASK *make_task_list (files *, TASK *, LASCII *, TASK*);
Boolean InitializeAll (void);
void Exit (void);

/*
 *	window.c
 */
Boolean make_window (TASK *);
void dispose_window (TASK *);

/*
 *	event.c
 */
Boolean Idle (void);
Boolean MSLDown (void);
Boolean MSLUp (void);
Boolean MSRDown (void);
Boolean MSRUp (void);
Boolean KeyDown (void);
Boolean KeyUp (void);
Boolean Update (void);
Boolean Activate (void);
Boolean System (void);

Boolean MSLDownSub (TASK *);
Boolean HideTask (TASK *);
Boolean ShowTask (TASK *);
void Extract (int, unsigned char*);
void ExtractOneWindow (int, unsigned char*, TASK*);

/*
 *	scrollbar.c
 */
Boolean open_scrollbar (TASK *);
Boolean dispose_scrollbar (TASK *);
void re_calc_scrollbar (TASK *);
void hide_scrollbar (TASK *);
void show_scrollbar (TASK *);
void draw_scrollbar (TASK *);

/*
 *	menu.c
 */
Boolean open_menus (TASK *);
void dispose_menus (TASK *);
Boolean select_menus (TASK *);
Boolean select_shift_menus (TASK *);
Boolean select_xf1_menus (TASK *);

/*
 *	archiver.c
 */
Boolean SystemProc (void);
Boolean exec_archiver (unsigned char *);
void write_command (int, int*, unsigned char*, int);
void make_xdrg (XDRG *);

/*
 *	files.c
 */
Boolean make_directory_list (files *);
files* search_files ( files *, int );
void dispose_files (files *);
void sort_files (files *, int, int);

/*
 *	icon.c
 */
icstate *make_icons (TASK *);
Boolean place_icons (TASK *);
void dispose_icons (TASK *);
Boolean draw_icons (TASK *);
Boolean draw_a_icon (TASK *, int);
Boolean change_pattern (TASK *, int, int);
int ISPtInIcon (TASK *, point_t);
Boolean SetisSelFlag (TASK *, int, int, int);
void select_icons_in_rect (TASK *, rect *);

/*
 *	options.c
 */
int get_options (void);

/*
 *	usage.c
 */
Boolean show_usage (void);
Boolean get_archive (void);

/*
 *	misc.c
 */
void FatalError (char *,...);
unsigned char * _toslash (unsigned char *);
unsigned char * _tobslash (unsigned char *);
Boolean Remove (const unsigned char *);
Boolean get_filename (unsigned char *, unsigned char *);
Boolean put_filename (unsigned char *, unsigned char *);
Boolean get_wild_card (TASK *T);
Boolean get_extract_directory (void);

/*
 *	library
 */
DPB * a39a (int);
int a3b3 (int, icstate *, rect *);
handle a3ba (icstate **, int, int, int);
int a3c5 (handle, unsigned char *);
menu **a3eb (handle);
int a3ec (handle, short, unsigned char*);
int a3ed (handle, handle);
int a40e (icstate **, int, int, pointer, rect *);

/*
 *	libc functions
 */
int _mode2dos (unsigned int);
unsigned int _mode2unix (int);
