/*
 * icon.c - for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: icon.c,v 1.5 1993/10/08 00:26:41 Niggle Exp $";

/*
 *$Log: icon.c,v $
 * Revision 1.5  1993/10/08  00:26:41  Niggle
 * ACRN^Oς̂tBbNX
 *
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/05/04  13:15:39  Niggle
 * oOtBbNX
 *
 * Revision 1.2  1993/04/29  03:01:26  Niggle
 * ኱̍
 *
 * Revision 1.1  1993/04/09  11:51:38  Niggle
 * Initial revision
 *
 */


/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<sys/stat.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* File scope functions */
static int MakeISRecOne (files *, icstate *);
static int SetIconSize (icstate *, int);


/* Inline functions */
/************************************************
 *		ACR			*
 ************************************************/
static inline int
ISDrawIconOne (icstate * I)
{
  register int result asm ("d0");
  asm volatile ("move.l\t%1,-(sp)\n"
		"\t.dc.w\t$a3b2\n"
		"\taddq.w\t#4,sp"
		:"=r" (result)
		:"g" (I)
		:"a0");
  return result;
}

/************************************************
 *		h[[h̐ݒ		*
 ************************************************/
static inline int
ISSetDrawMode (icstate * ISRec, int drawMode, int eqFlag)
{
  register int result asm ("d0");
  asm volatile ("move.w\t%2,-(sp)\n"
		"\tmove.l\t%1,-(sp)\n"
		"\t.dc.w\t$a3c4\n"
		"\taddq.w\t#6,sp"
		:"=r" (result)
		:"g" (ISRec), "g" ((drawMode * 0x100 + eqFlag) & 0xffff)
		:"a0");
  return result;
}

/************************************************
 *	t@CACRԍ߂	*
 ************************************************/
static inline int
GetIconNum (unsigned char *fileName, int attribute, unsigned char *pathName)
{
  register int result asm ("d0");
  asm volatile ("pea\t(%3)\n"
		"\tmove.w\t%2,-(sp)\n"
		"\tpea\t(%1)\n"
		"\t.dc.w\t$a3b4\n"
		"\tlea.l\t10(sp),sp"
		:"=r" (result)
		:"a" (fileName), "d" (attribute), "a" (pathName)
		:"a0");
  return result;
}

/************************************************
 *	[U[ACRCfbNX𓾂	*
 ************************************************/
static inline pointer
ISGetIconIndex (pointer * h)
{
  register pointer IconIndex asm ("a0");
  asm (".dc.w\t$a3ac\n": "=r" (IconIndex): :"d0");
  *h = IconIndex;
  return IconIndex;
}

/************************************************
 *		[hݒ			*
 ************************************************/
static inline int
ISSetIconMode (icstate ** ISRecHdl, int first, int last, int dstMode, int srcMode, int DrawMode, rect * src)
{
  register int result asm ("d0");
  asm volatile ("move.l\t%7,-(sp)\n"
		"\tmove.w\t%6,-(sp)\n"
		"\tmove.l\t%5,-(sp)\n"
		"\tmove.l\t%4,-(sp)\n"
		"\tmove.w\t%3,-(sp)\n"
		"\tmove.w\t%2,-(sp)\n"
		"\tmove.l\t%1,-(sp)\n"
		"\t.dc.w\t$a3b1\n"
		"\tlea.l\t22(sp),sp"
		:"=r" (result)
		:"g" (ISRecHdl), "r" (first), "r" (last), "g" (dstMode), "g" (srcMode),
		"r" (DrawMode), "g" (src)
		:"a0");
  return result;
}


/* Functions */
/****************************************************************
 *	files XgACRǗR[h̔z	*
 ****************************************************************/
icstate *
make_icons (TASK * T)
{
  files *cur;
  icstate *ISRec;
  int i;
  int iconNum = 0;

  cur = &T->files;
  for (cur = T->files.next; cur != NULL; cur = cur->next)
    iconNum++;

  T->ISRec = calloc (iconNum, sizeof (icstate));
  if (!(ISRec = T->ISRec))
    {
      FatalError ("make_icons: Memory Exaust.");
      return NULL;
    }

  for (i = 0, cur = T->files.next; cur != NULL; i++, ISRec++, cur = cur->next)
    {
      MakeISRecOne (cur, ISRec);
      ISRec->pathPtr = (char *) T->extract_directory;
      cur->IsRecNum = i;
    }
  T->sNum = 0;
  T->eNum = i;
  place_icons (T);

  return T->ISRec;
}

/************************************************
 *	ACRu			*
 ************************************************/
Boolean
place_icons (TASK * T)
{
  int i;
  rect r;
  icstate *I = T->ISRec;

  r = T->winPtr->wGraph.grRect;
  r.right -= SCB_WIDTH;
  r.bottom = r.top;

  for (i = T->sNum; i < T->eNum; I++, i++)
    {
      a3b3 (i, I, &r);
      SetIconSize (I, 1);
    }

  a40e (&T->ISRec, T->sNum, T->eNum, 0, &T->dRect);

  return nil;
}

/************************************************
 *	ACRǗR[h Free 	*
 ************************************************/
void
dispose_icons (TASK * T)
{
  icstate *I;

  if ((I = T->ISRec))
    free (I);
}


/****************************************
 *	ACR		*
 ****************************************/
Boolean
draw_icons (TASK * T)
{
  rect R = T->winPtr->wGraph.grRect;
  R.right -= SCB_WIDTH;
  R.bottom -= SCB_WIDTH;

  asm volatile ("move.l\t%4,-(sp)\n"
		"\tmove.l\t%3,-(sp)\n"
		"\tmove.w\t%2,-(sp)\n"
		"\tmove.w\t%1,-(sp)\n"
		"\tmove.l\t%0,-(sp)\n"
		"\t.dc.w\t$a3b0\n"
		"\tlea.l16(sp),sp"
		:
		:"g" (&T->ISRec), "r" (T->sNum), "r" (T->eNum), "g" (&R), "g" (0)
		:"a0", "d0");

  return nil;
}

/****************************************
 *	ACR		*
 ****************************************/
Boolean
draw_a_icon (TASK * T, int num)
{
  return ISDrawIconOne (&T->ISRec[num]);
}

/************************************************
 *	pt wACRԍԂ		*
 ************************************************/
int
ISPtInIcon (TASK * T, point_t pt)
{
  register int Num asm ("d0");
  asm volatile ("move.l\t%4,-(sp)\n"
		"\tmove.w\t%3,-(sp)\n"
		"\tmove.w\t%2,-(sp)\n"
		"\tmove.l\t%1,-(sp)\n"
		"\t.dc.w\t$a3ae\n"
		"\tlea.l\t12(sp),sp"
		:"=r" (Num)
		:"g" (&T->ISRec), "r" (T->sNum), "r" (T->eNum), "g" (pt)
		:"a0");
  return Num;
}

/************************************************
 *	rect Ɋ܂܂ACRI	*
 ************************************************/
void
select_icons_in_rect (TASK * T, rect * r)
{
  icstate *I;
  int i;

  for (I = T->ISRec, i = 0; i < T->eNum + 1; I++, i++)
    {
      rect tmp;

      if (GMAndRect (&tmp, r, &I->image))
	SetisSelFlag (T, i, i + 1, -1);
    }
}

/************************************************
 *		ItO̐ݒ		*
 ************************************************/
Boolean
SetisSelFlag (TASK * T, int sNum, int eNum, int mode)
{
  rect r;
  region **rHdl;

  rHdl = GMNewRgn ();
  GMGetClip (rHdl);
  r = T->winPtr->wGraph.grRect;
  r.right -= SCB_WIDTH;
  r.bottom -= SCB_WIDTH;
  GMClipRect (&r);

  if (mode > 0)
    {
      ISSetIconMode (&T->ISRec, sNum, eNum, 0x017f7f7f, 0x007f7f7f, 0x7f, 0);
    }
  else if (mode < 0)
    {
      int i;

      for (i = sNum; i < eNum; i++)
	{
	  if (T->ISRec[i].rsv[0] == 0)
	    ISSetIconMode (&T->ISRec, i, i + 1, 0x017f7f7f, 0x007f7f7f, 0x7f, 0);
	  else
	    ISSetIconMode (&T->ISRec, i, i + 1, 0x007f7f7f, 0x017f7f7f, 0x7f, 0);
	}
    }
  else
    {
      ISSetIconMode (&T->ISRec, sNum, eNum, 0x007f7f7f, 0x017f7f7f, 0x7f, 0);
    }

  GMSetClip (rHdl);
  GMDisposeRgn (rHdl);
  return nil;
}

/************************************************
 *	ACRp^[ύX		*
 ************************************************/
Boolean
change_pattern (TASK * T, int iNum, int id)
{
  icstate *I = &T->ISRec[iNum];

  I->iconid = id;
  a3b3 (iNum, I, &T->dRect);
  SetIconSize (I, 1);

  return nil;
}


/* File scope functions */
/****************************************************************
 *	t@Cl[ACRǗR[h쐬	*
 ****************************************************************/
static int
MakeISRecOne (files * F, icstate * ISRec)
{
  get_filename ((unsigned char *) ISRec->name, F->fileName);
  ISRec->attr = _mode2dos (F->attribute);
  ISRec->opt1 = 0;
  ISRec->opt2 = 0;
  ISRec->mediabyte = spool_media_byte;
  ISRec->unitno = spool_unit_no;
  if (S_ISDIR (F->attribute))
    {
      ISRec->iconid = DIR_ICON_NUM;
      strncpy (ISRec->name, (char *)F->dirName, 18);
      ISRec->name[strlen (ISRec->name) - 1] = '\0';
    }
  else
    {
      ISRec->iconid = GetIconNum ((unsigned char *) ISRec->name, 0, F->dirName);
    }
  ISRec->pathPtr = "";
  if (ISRec->attr & 1)
    {
      ISRec->bitflag = 64;
    }
  else
    {
      ISRec->bitflag = 0;
    }
  ISRec->drawMode = 0;
  *(int *) &ISRec->rsv = 1;

  ISRec->image = (rect)
  {
    0, 0, 0, 0
  };
  return nil;

}

/********************************************************
 *	ACRǗR[hACR̃TCY𓾂	*
 ********************************************************/
static int
SetIconSize (icstate * I, int r)
{
  register int result asm ("d0");
  asm volatile ("move.w\t%2,-(sp)\n"
		"\tmove.l\t%1,-(sp)\n"
		"\t.dc.w\t$a3ad\n"
		"\taddq.w\t#6,sp\n"
		:"=r" (result)
		:"r" (I), "r" (r)
		:"a0");
  if (result)
    return t;

  return nil;
}
