/*
 * menu.c - menu functions for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: menu.c,v 1.5 1993/10/08 00:26:41 Niggle Exp $";

/*
 *$Log: menu.c,v $
 * Revision 1.5  1993/10/08  00:26:41  Niggle
 * 𓀎Ƀ^CX^vrg悤ɏύX
 *
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/05/04  13:16:50  Niggle
 * re-format only
 *
 * Revision 1.2  1993/04/29  21:10:29  Niggle
 * re-format only
 *
 * Revision 1.1  1993/04/09  14:11:22  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"
#include"archiver.h"


/* File scope functions */
static void re_place_icon (TASK *);


/* File scope variables */
static LASCII *Title = (LASCII *) "\@SEChE";


/* Functions */
/************************************************
 *	j[				*
 ************************************************/
Boolean
open_menus (TASK * T)
{
  T->menuHdl1 = MNConvert (NULL, "A[JCu,^aׂĂI,ChJ[h,,^x,^o𓀐̃I[v,~,^qN[Y", 0);
  T->menuHdl2 = MNConvert (NULL, ",O,gq,t,TCY", 0);
  T->menuHdl3 = MNConvert (NULL, "A[JCu,^AׂĂI,ChJ[h,,^X,^d𓀐ύX,~,^QI", 1);
  (*(T->menuHdl3))->mHandle = (long) Title;
  return nil;
}

/************************************************
 *	j[p				*
 ************************************************/
void
dispose_menus (TASK * T)
{
  if (T->menuHdl1)
    MMHdlDispose ((handle) T->menuHdl1);
  if (T->menuHdl2)
    MMHdlDispose ((handle) T->menuHdl2);
  if (T->menuHdl3)
    MMHdlDispose ((handle) T->menuHdl3);

  return;
}

/************************************************
 *	ʂ̃j[			*
 ************************************************/
Boolean
select_menus (TASK * T)
{
  switch (MNSelect (T->menuHdl1, tsEventRec.whom2))
    {
    case 1:
      {
	/* A[JCu	 info.r N */
	LASCII cmdLine;

	mbscpy (cmdLine.Lstr, ArcFileName);
	cmdLine.length = strlen ((char *) ArcFileName);
	TSFockB (0, 0, "info.r", &cmdLine, 0, 0);
      }
      break;
    case 2:
      /* ׂẴACȒItOZbg */
      SetisSelFlag (T, T->sNum, T->eNum, 1);
      break;
    case 3:
      /* ChJ[hw */
      return get_wild_card (T);
      break;
    case 4:
      /* ACR𐮓 */
      re_place_icon (T);
      break;
    case 5:
      /*  */
      ExtractOneWindow (AE_TMSTMP, DstDirName, T);
      if (!auto_open_p)
	break;
    case 6:
      {
	/* 𓀐I[v */
	LASCII options;

	options.length = strlen ((char *) DstDirName);
	mbscpy (options.Lstr, DstDirName);
	TSFockB (0, 0, "di.r", &options, 0, 0);
      }
      break;
    case 8:
      return HideTask (T);
      break;
    }
  return nil;
}

/************************************************
 *	shift ̃j[			*
 ************************************************/
Boolean
select_shift_menus (TASK * T)
{
  int item;

  item = MNSelect (T->menuHdl2, tsEventRec.whom2);
  if (item > 0)
    {
      int max = 0;
      files *cur;

      for (cur = T->files.next; cur != NULL; cur = cur->next)
	max++;

      sort_files (&T->files, max, item);

      if (T->ISRec)
	{
	  rect *wr, *dr;
	  dr = &T->dRect;
	  wr = &T->winPtr->wGraph.grRect;

	  dispose_icons (T);
	  dr->left = 0;
	  dr->top = 0;
	  dr->right = wr->right - wr->left;
	  dr->bottom = 0;
	  make_icons (T);

	  {
	    rect r = *wr;
	    r.right -= (SCB_WIDTH);
	    r.bottom -= (SCB_WIDTH);

	    GMSetGraph (&T->winPtr->wGraph);
	    GMPenMode (G_BACK);
	    GMFillRect (&r);
	    GMPenMode (G_FORE);
	  }

	  GMSetHome (0);
	  re_calc_scrollbar (T);
	  (*T->draw_proc) (T);
	}

    }
  return nil;
}

/************************************************
 *	SEChEɑ΂Ẵj[		*
 ************************************************/
Boolean
select_xf1_menus (TASK * T)
{
  switch (MNSelect (T->menuHdl3, tsEventRec.whom2))
    {
    case 1:
      {
	/* A[JCu info.r N */
	LASCII cmdLine;
	mbscpy (cmdLine.Lstr, ArcFileName);
	cmdLine.length = strlen ((char *) ArcFileName);
	TSFockB (0, 0, "info.r", &cmdLine, 0, 0);
      }
      break;
    case 2:
      {
	/* SEChẼACȒItOZbg */
	TASK *cur;

	for (cur = MyTASK.next; cur != NULL; cur = cur->next)
	  {
	    if (cur->ISRec)
	      {
		GMSetGraph (&cur->winPtr->wGraph);
		SetisSelFlag (cur, cur->sNum, cur->eNum, 1);
	      }
	  }
      }
      break;
    case 3:
      /* ChJ[hw */
      return get_wild_card (0);
      break;
    case 4:
      {
	/* SEChẼACR𐮓 */
	TASK *cur;

	for (cur = MyTASK.next; cur != NULL; cur = cur->next)
	  {
	    if (cur->ISRec)
	      {
		GMSetGraph (&cur->winPtr->wGraph);
		re_place_icon (cur);
	      }
	  }
      }
      break;
    case 5:
      Extract (AE_TMSTMP, DstDirName);
      if (auto_open_p)
	{
	  LASCII options;

	  options.length = strlen ((char *) DstDirName);
	  mbscpy (options.Lstr, DstDirName);
	  TSFockB (0, 0, "di.r", &options, 0, 0);
	}
      break;
    case 6:
      return get_extract_directory ();
      break;
    case 8:
      return t;
      break;
    }
  return nil;
}


/* File scope functions */
/************************************************
 *	ACR𐮓				*
 ************************************************/
static void
re_place_icon (TASK * T)
{
  rect *dr, *wr;

  dr = &T->dRect;
  wr = &T->winPtr->wGraph.grRect;

  *dr = (rect)
  {
    0, 0, 0, 0
  };
  dr->right = wr->right - wr->left;

  place_icons (T);

  {
    rect r = *wr;
    r.right -= (SCB_WIDTH);
    r.bottom -= (SCB_WIDTH);

    GMSetGraph (&T->winPtr->wGraph);
    GMPenMode (G_BACK);
    GMFillRect (&r);
    GMPenMode (G_FORE);
  }

  GMSetHome (0);		/* z[ʒu炷 */
  re_calc_scrollbar (T);
  (*T->draw_proc) (T);
}
