/*
 * options.c - for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: options.c,v 1.5 1993/09/21 05:31:32 Niggle Exp $";

/*
 *$Log: options.c,v $
 * Revision 1.5  1993/09/21  05:31:32  Niggle
 * *** empty log message ***
 *
 * Revision 1.4  1993/05/04  13:19:17  Niggle
 * re-format only
 *
 * Revision 1.3  1993/04/25  19:07:31  Niggle
 * re-format only
 *
 * Revision 1.2  1993/04/12  12:09:31  Niggle
 * 𓀐悪w肳ĂȂɂ́CA[JCûpX
 * 𓀂悤ɂD
 *
 * Revision 1.1  1993/04/09  15:13:27  Niggle
 * Initial revision
 *
 */


/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<limits.h>
#include<sys/stat.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* Functions */
/************************************************
 *	IvV				*
 ************************************************/
int
get_options (void)
{
  task MyTdb;			/* TSTakeParam p */
  int argc;
  unsigned char **argv;
  unsigned char buf[PATH_MAX + 1];
  int result;

  TSGetTdb (&MyTdb, -1);
  result = TSTakeParam (&MyTdb.command, &MyWinRect, (char *) buf, 1, 0, (char **) &argv);

  if (!(result & 1))
    {
      /*  EChEʒuw肳Ăꍇ  */
      *(point_t *) & MyWinRect.left = TSGetWindowPos ();
      MyWinRect.right = MyWinRect.left + WIN_X;
      MyWinRect.bottom = MyWinRect.top + WIN_Y;
    }

  MMPtrDispose (argv);

  if (result & 2)
    {
      int c;

      extern int _argc;
      extern unsigned char **_argv;

      argc = _argc;
      argv = _argv;

      opterr = 0;		/* suppress getopt-error-messeage */
      optind = 1;

      directory_p = t;
      file_p = t;
      *SortName = '\0';

      while ((c = getopt (argc, (char **) argv, "d:s:S:carv")) != EOF)
	{
	  switch (c)
	    {
	    case 'd':
	      mbscpy (DstDirName, (unsigned char *) optarg);
	      break;
	    case 's':
	      mbscpy (SpoolDirName, (unsigned char *) optarg);
	      break;
	    case 'S':
	      mbscpy (SortName, (unsigned char *) optarg);
	      break;
	    case 'c':
	      clip_p = t;
	      break;
	    case 'v':
	      version_p = t;
	      break;
	    case 'r':
	      recursive_p = t;
	      break;
	    case 'a':
	      auto_open_p = t;
	      break;
	    default:
	      break;
	    }
	}

      if (optind != argc)
	{
	  mbscpy (ArcFileName, argv[optind++]);
	}
    }

  mbscpy (wild.Lstr, (unsigned char *) "*.*");
  wild.length = strlen ((char *) wild.Lstr);

  sort_kind = atoi ((char *) SortName);
  if (sort_kind < 0 || sort_kind > 5)
    sort_kind = 0;

  if (!(*ArcFileName))
    version_p = t;
  else if (!(*DstDirName))
    {
      unsigned char *slash;

      mbscpy (DstDirName, ArcFileName);
      slash = mbsrchr (DstDirName, '\\');
      if (slash)
	*slash = '\0';
      else
	{
	  FatalError ("A[JCu̓tpXŎw肵ĂD\n");
	  *ArcFileName = '\0';
	  version_p = t;
	}
    }


  if (!strlen ((char *) SpoolDirName))
    {
      char *drive = NULL;

      drive = getenv ("SYSROOT");
      mbscpy (SpoolDirName, (unsigned char *) "a:\\usr\\spool\\vison");
      if (drive)
	{
	  SpoolDirName[0] = drive[0];
	}
    }
  {
    struct stat stbuf;
    _toslash (SpoolDirName);
    if (stat ((char *) SpoolDirName, &stbuf))
      {
	unsigned char *TMP = NULL;

	TMP = (unsigned char *) getenv ("temp");
	if (TMP)
	  {
	    unsigned char *slash;

	    mbscpy (SpoolDirName, TMP);
	    slash = mbsrchr (SpoolDirName, '\\');
	    if ((slash - SpoolDirName + 1) != strlen ((char *) SpoolDirName))
	      mbscat (SpoolDirName, (unsigned char *) "\\");
	  }
      }
    _tobslash (SpoolDirName);
  }

  return nil;
}
