/*
 * skelton.c - main event loop for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: skelton.c,v 1.4 1993/09/21 04:11:18 Niggle Exp $";

/*
 *$Log: skelton.c,v $
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/04/29  21:09:21  Niggle
 * I̕ύX
 *
 * Revision 1.2  1993/04/12  12:06:23  Niggle
 * R}hC̋NłȂoOtBbNX
 *
 * Revision 1.1  1993/04/09  14:08:34  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* Macros */
#ifdef NDEBUG
__common char _sxkernelcomm[] = "sxkernel";
#else /* NDEBUG */
__common char _sxkernelcomm[] = "sxwdb -d";
#endif /* !NDEBUG */


/* File scope variables */
static int count = 0;


/* Functions */
/************************************************
 *	main event loop				*
 ************************************************/
volatile void
main (void)
{
  Boolean result;

  if ((SXVer () & 0xffff) < SX_VERSION)
    {
      FatalError ("SX-WINDOW v%d.%02dȍ~płD", (SX_VERSION >> 8), (SX_VERSION & 0xff));
      result = t;
    }
  else
    {
      EMEnCross ();
      result = InitializeAll ();
      EMDeCross ();

      while (!result)
	{
	  TSEventAvail (tsEventMask, &tsEventRec);
	  switch (tsEventRec.what)
	    {
	    case E_IDLE:
	      result = Idle ();
	      break;
	    case E_MSLDOWN:
	      result = MSLDown ();
	      break;
	    case E_MSLUP:
	      result = MSLUp ();
	      break;
	    case E_MSRDOWN:
	      result = MSRDown ();
	      break;
	    case E_MSRUP:
	      result = MSRUp ();
	      break;
	    case E_KEYDOWN:
	      result = KeyDown ();
	      break;
	    case E_KEYUP:
	      result = KeyUp ();
	      break;
	    case E_UPDATE:
	      result = Update ();
	      break;
	    case E_ACTIVATE:
	      result = Activate ();
	      break;
	    case E_SYSTEM1:
	    case E_SYSTEM2:
	      result = System ();
	      break;
	    }

	  if (result && extract_p)
	    {
	      if (count++ > 0)
	        {
		  result = TSErrDialogN (7, "𓀏IɏI܂D\n");
		  if (result == 1)
		    {
		      exit_p = t;
		      result = 0;
		    }
	        }
	      else if (count > 5)
		{
		  break;
	        }
	    }
	}
    }
  EMEnCross ();
  Exit ();
  EMDeCross ();
  exit (result);
}
